// Mod: Month/Year List for Xin Calendar 2 (In-Page/Popup-Window)
// Copyright 2004  Xin Yang    All Rights Reserved.

// Last Modified: 20-Aug-2004

// Internal function
function xcScrollYear(idx,y) { xcMoveYear(idx,y-xcFindCal(idx).year); }
function xcScrollMonth(idx,m) { xcMoveMonth(idx,m-xcFindCal(idx).month); }
function xcScrollList(func,para) { return func+"("+para+")"; }

// Overloaded function
function xcCalMonthYear() {
  var monthList="", yearList="";

  monthList+=xcTagOpen("SELECT",xcCSSMonthYearList,"ONCHANGE='"+xcScrollList("xcScrollMonth",this.idx+",this.selectedIndex")+"'");
  for (var i=0; i<12; i++) {
    monthList+="<OPTION VALUE='"+i+"'";
    if (i==this.month) { monthList+=" SELECTED"; }
    monthList+=">"+xcMonthPrefix;
    if (xcMonthListFormat=="Month") {
      monthList+=xcMonthNames[i];
    }
    else if (xcMonthListFormat=="MONTH") {
      monthList+=xcMonthNames[i].toUpperCase();
    }
    else if (xcMonthListFormat=="Mon") {
      monthList+=xcMonthShortNames[i];
    }
    else if (xcMonthListFormat=="MON") {
      monthList+=xcMonthShortNames[i].toUpperCase();
    }
    else {
      monthList+=xcGetDD(i+1);
    }
    monthList+=xcMonthSuffix+"</OPTION>";
  }
  monthList+="</SELECT>";

  yearList+=xcTagOpen("SELECT",xcCSSMonthYearList,"ONCHANGE='"+xcScrollList("xcScrollYear",this.idx+",this.value")+"'");
  for (var i=this.year-xcYearListRange; i<=this.year+xcYearListRange; i++) {
    yearList+="<OPTION VALUE='"+i+"'";
    if (i==this.year) { yearList+=" SELECTED"; }
    yearList+=">"+xcYearPrefix;
    if (i==this.year-xcYearListRange) {
      yearList+=xcYearListPrevRange;
    }
    yearList+=xcGetYearString(i)+xcYearSuffix;
    if (i==this.year+xcYearListRange) {
      yearList+=xcYearListNextRange;
    }
    yearList+="</OPTION>";
  }
  yearList+="</SELECT>";

  if (xcHeadTagOrder==1) {
    return xcTDDIV(xcCSSHead,monthList,"")+xcTDDIV(xcCSSHead,yearList,"");
  }
  else {
    return xcTDDIV(xcCSSHead,yearList,"")+xcTDDIV(xcCSSHead,monthList,"");
  }
}
